using System;
using JJC.Psharp.Predicates;
using JJC.Psharp.Lang;

namespace Treeify {
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1 {

		static string Munge( string sin ) {
			int len = sin.Length;
			string lessdotpl = sin.Substring( 0, len - 3 );
			lessdotpl = lessdotpl.Replace( '-', '.' );
			return lessdotpl + "_database";
		}

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args) {
			PrologInterface sharp = new PrologInterface( new PushbackReader( System.Console.In ),
				System.Console.Out, System.Console.Error, true );
			// arg1: System-Drawing.pl
			// arg2: System.Drawing_namespace.pl

			Term arg1 = SymbolTerm.makeSymbol( args[ 0 ] );
			Term arg2 = SymbolTerm.makeSymbol( Munge( args[ 0 ] ) );
			sharp.addCallingAssembly( );
			Term ret = new VariableTerm( );
			sharp.setPredicate( new Treeify_3( arg1, arg2, ret, new ReturnCs( sharp ) ) );
			sharp.call( );
			//
			// TODO: Add code to start application here
			//
		}
	}
}
