namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_newStringWriter_1 : Predicate {
		Term arg1;

		public dollar_newStringWriter_1(Term a1, Predicate cont) {
			arg1 = a1;
			this.cont = cont;
		}
		public dollar_newStringWriter_1() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1;
			a1 = arg1.dereference();
			
			object sw = new System.IO.StringWriter( );
			CsObjectTerm ot = new CsObjectTerm( sw );
			if( !a1.unify( ot, engine.trail ) )
				return engine.fail( );
			return cont;
		}

		public override int arity() { return 1; }

		public override string ToString() {
			return "$new_string_writer(" + arg1 + ")";
		}
	}
}