/*
 * @(#)ReturnJava.cs
 */

/* 
 * @author Mutsunori Banbara 
 *         banbara@pascal.seg.kobe-u.ac.jp
 *         Nara National College of Technology
 * @author Naoyuki Tamura 
 *         tamura@kobe-u.ac.jp
 *         Kobe University
 */

namespace JJC.Psharp.Lang {

	public sealed class ReturnCs : Predicate {
		public PrologInterface p;

		// public ReturnJava(){}
		public ReturnCs( PrologInterface p ){
			this.p = p;
		}
		// public final void setArgument(Term[] args, Predicate cont){
		//		this.cont = cont;
		// }
		public override Predicate exec( Prolog engine ) {
			p.success();
			return engine.fail();
		}

		// POSSIBLE SPEEDUP JJC.
		public override void setArgument( Term[] t, Predicate p ) {
			throw new System.Exception( );
		}

		public override string ToString(){ return "RetrunJava";}
		public override int arity() { return 0; }
	}

}