@echo off
REM ----------------------------------------
REM Pass this script the filename of a SINGLE
REM prolog file (extension .pl).

REM Make appropriate settings in this section:

set PN_ROOT=%CD%

set SPLITINTOPREDICATES="%PN_ROOT%\Split into Predicates\SplitIntoPredicates"
set TREEIFY="%PN_ROOT%\Treeify\Treeify"
set PSHARPINTRP="p#lb"
REM "%PN_ROOT%\..\..\Psharp\PsharpIntrp\PsharpIntrp"
set ASSEMBLYINFO="%PN_ROOT%\AssemblyInfo.cs"
set PSHARP_DLL="%PN_ROOT%\Treeify\Psharp.dll"
set CSHARPCOMPILE="csc"
set GENKEY="sn"

REM ----------------------------------------
FOR %%F in (%1) do set FILESTART=%%~nF
echo Processing: %FILESTART%
mkdir %FILESTART%.dir
cd %FILESTART%.dir
del *.pl 2>NUL
del *.cs 2>NUL
del *.dll 2>NUL
copy ..\%FILESTART%.pl .
%SPLITINTOPREDICATES% %FILESTART%.pl
del %FILESTART%.pl
FOR %%F in (*~*) do call %TREEIFY% %%F
mkdir tocompile
FOR %%F in (*~~*) do copy %%F tocompile
cd tocompile
FOR %%F in (*.pl) do echo compile( '%%~nF' ). > script%%~nF
del *.cs 2>NUL
FOR %%F in (*.pl) do call %PSHARPINTRP% < script%%~nF
%GENKEY% -k strong.snk
copy %ASSEMBLYINFO% .
%CSHARPCOMPILE% /r:%PSHARP_DLL% /target:library /out:%FILESTART%.dll *.cs
move %FILESTART%.dll ..\..
del *.pl
del *.cs
del script*
del strong.snk
cd ..
rmdir tocompile
del *.pl
cd ..
rmdir %FILESTART%.dir
