/*
 *  @(#)dollar_atom_1.cs
 *  $B=R8l(B $atom/1
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_atom_1 : Predicate {
		Term arg1;

		public dollar_atom_1(Term a1, Predicate cont) {
			arg1 = a1;
			this.cont = cont;
		}
		public dollar_atom_1() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1;
			a1 = arg1.dereference();

			if( ! a1.isSymbol() ) 
				return engine.fail();
			return cont;
		}

		public override int arity() { return 1 ; }

		public override string ToString() {
			return "$atom(" + arg1 + ")";
		}
	}

}